<?php

class MasterBadge_ControllerAdmin_Badge extends XenForo_ControllerAdmin_Abstract
{

/* Start auto-generated lines of code. */

    public function actionIndex()
    {
        return $this->responseRedirect(
            XenForo_ControllerResponse_Redirect::SUCCESS,
            XenForo_Link::buildAdminLink('trophies')
        );
    }

    protected function _getBadgeAddEditResponse(array $badge)
    {
        $viewParams = array(
            'badge' => $this->_getBadgeModel()->prepareBadge($badge)
        );

        return $this->responseView('MasterBadge_ViewAdmin_Badge_Edit', 'MasterBadge_badge_edit', $viewParams);
    }

    public function actionAdd()
    {
        return $this->_getBadgeAddEditResponse(array(
            'display_order' => 10,
            'visible' => 1
        ));
    }

    public function actionEdit()
    {
        $badge = $this->_getBadgeOrError();

        return $this->_getBadgeAddEditResponse($badge);
    }

    public function actionSave()
    {
        $this->_assertPostOnly();

        $badgeId = $this->_input->filterSingle('badge_id', XenForo_Input::UINT);    

        $dwInput = $this->_input->filter(array(
            'display_order' => XenForo_Input::UINT,
            'type' => XenForo_Input::STRING,
        ));

        $input = $this->_input->filter(array(
            'title' => XenForo_Input::STRING
        ));

        $dw = XenForo_DataWriter::create('MasterBadge_DataWriter_Badge');
        if ($badgeId)
        {
            $dw->setExistingData($badgeId);
        }

        $dw->bulkSet($dwInput);
        $dw->setExtraData(MasterBadge_DataWriter_Badge::DATA_TITLE, $input['title']);
        $dw->save();

        return $this->responseRedirect(
            XenForo_ControllerResponse_Redirect::SUCCESS,
            XenForo_Link::buildAdminLink('trophies') . '#_b' . $dw->get('badge_id')
        );
    }

    public function actionDelete()
    {
        $badge = $this->_getBadgeOrError();;

        if ($this->isConfirmedPost())
        {
            $dw = XenForo_DataWriter::create('MasterBadge_DataWriter_Badge');
            $dw->setExistingData($badge);
            $dw->delete();

            return $this->responseRedirect(
                XenForo_ControllerResponse_Redirect::SUCCESS,
                XenForo_Link::buildAdminLink('trophies')
            );
        } 
        else 
        {
            $viewParams = array(
                'badge' => $badge,
            );

            return $this->responseView('MasterBadge_ViewAdmin_Badge_Delete', 'MasterBadge_badge_delete', $viewParams);
        }
    }

    protected function _getBadgeOrError($id = null, array $fetchOptions = array())
    {
        if ($id === null)
        {
            $id = $this->_input->filterSingle('badge_id', XenForo_Input::UINT);
        }

        $badge = $this->_getBadgeModel()->getBadgeById($id, $fetchOptions);

        if (!$badge)
        {
            throw $this->responseException($this->responseError(new XenForo_Phrase('MasterBadge_badge_not_found'), 404));
        }

        return $badge;
    }

    protected function _getBadgeModel()
    {
        return $this->getModelFromCache('MasterBadge_Model_Badge');
    }

/* End auto-generated lines of code. */

    public function actionLevelEditor()
    {
        return $this->responseMessage('Comming soon');
    }

    public function actionLevelCalculator()
    {
        if ($this->_request->isPost())
        {
            $level = $this->_input->filterSingle('level', XenForo_Input::UINT);

            $this->_routeMatch->setResponseType('json');
            return $this->responseView('MasterBadge_ViewAdmin_Level_Calculator', '', array('level' => $level));
        }
        else
        {
            $pointsPerLevel = XenForo_Application::getOptions()->MasterBadge_pointsPerLevel;
            $levelOptions = array(
                'persistent' => new XenForo_Phrase('MasterBadge_amount_level_up_same_each_level'),
                'increase1' => new XenForo_Phrase('MasterBadge_amount_level_up_increases_every_level', array('points' => $pointsPerLevel)),
                'increase10' => new XenForo_Phrase('MasterBadge_amount_level_up_increases_every_10levels', array('points' => $pointsPerLevel)),
            );

            $levels = array();

            for ($i = 1;$i <= 10;$i++) 
            { 
                $levels[$i]['start'] = ($i - 1) * 10 + 1;   
                $levels[$i]['end'] = $i * 10;
            }

            $viewParams = array(
                'levelUp' => $levelOptions[XenForo_Application::getOptions()->MasterBadge_levelUp],
                'levels' => $levels
            );

            return $this->responseView('MasterBadge_ViewAdmin_Level_Calculator', 'MasterBadge_level_calculator', $viewParams);
        }
    }
}