<?php

class MasterBadge_ControllerPublic_Account extends XFCP_MasterBadge_ControllerPublic_Account
{
    public function actionPersonalDetails()
    {
        $response = parent::actionPersonalDetails();

        if ($response instanceof XenForo_ControllerResponse_View)
        {
            $visitor = XenForo_Visitor::getInstance()->toArray();

            if (!empty($visitor['favorite_badge']))
            {
                $badgeModel = $this->_getBadgeModel();

                $response->subView->params['favoriteBadgeIcons'] = array();

                $favoriteBadges = $badgeModel->getUserFeaturedBadges($visitor);

                foreach ($favoriteBadges as $trophyId => $trophy) 
                {
                    $response->subView->params['favoriteBadgeIcons'][] = XenForo_Template_Helper_Core::callHelper('trophyicon', array($trophy));
                }

                $response->subView->params['favoriteBadges'] = $badgeModel->limitFeaturedBadges($visitor, $favoriteBadges);
                $response->subView->params['favoriteBadgeIcons'] = $badgeModel->limitFeaturedBadges($visitor, $response->subView->params['favoriteBadgeIcons']);
            }
        }

        return $response;
    }

    public function actionPreferencesSave() 
    {
        $GLOBALS['MasterBadge_ControllerPublic_Account'] = $this;
        
        return parent::actionPreferencesSave();
    }
    
    public function MasterBadge_actionPreferencesSave(XenForo_DataWriter_User $dw)
    {
        $dwInput = $this->_input->filter(array(
            'auto_feature_badge' => XenForo_Input::UINT,
            'feature_badge_slide_options' => XenForo_Input::ARRAY_SIMPLE,
        ));

        /*if ($dwInput['auto_feature_badge'])
        {
            $trophies = $this->_getTrophyModel()->getTrophiesForUserId($dw->get('user_id'));

            $dw->set('favorite_badge', array_keys($trophies));
        }
        else
        {
            $dw->set('favorite_badge', false);
        }*/

        $dw->bulkSet($dwInput);
    }

    protected function _getTrophyModel()
    {
        return $this->getModelFromCache('XenForo_Model_Trophy');
    }

    protected function _getBadgeModel()
    {
        return $this->getModelFromCache('MasterBadge_Model_Badge');
    }
}