<?php

class MasterBadge_ControllerPublic_Member extends XFCP_MasterBadge_ControllerPublic_Member
{
    public function actionMember()
    {
        $response = parent::actionMember();

        if ($response instanceof XenForo_ControllerResponse_View)
        {
            $viewParams =& $response->params;

            $trophyModel = $this->_getTrophyModel();
            $badgeModel = $this->_getBadgeModel();

            $viewParams['favoriteBadges'] = $badgeModel->getUserFeaturedBadges($viewParams['user']);

            $trophies = $trophyModel->prepareTrophies($trophyModel->getTrophiesForUserId($viewParams['user']['user_id']));              
            $badges = $badgeModel->buildCurrentBadgeTropy($trophies);

            $viewParams['badgesCount'] = count($badges);
            $viewParams['badges'] = array_slice($badges, 0, MasterBadge_Const::BADGES_TO_SHOW_COUNT);
        }

        return $response;
    }

    public function actionTrophies()
    {
        $response = parent::actionTrophies();

        if ($response instanceof XenForo_ControllerResponse_View)
        {
            if (!XenForo_Application::getOptions()->MasterBadge_featured)
            {               
                return $response;
            }
        
            if ($response->params['user']['auto_feature_badge'])
            {
                throw $this->responseException($this->responseError(new XenForo_Phrase('MasterBadge_turn_off_auto_feature_badge')));
            }

            // if (!XenForo_Application::getOptions()->MasterBadge_featured)
            // {
            //     throw $this->responseException($this->responseError(new XenForo_Phrase('requested_page_not_found')));
            // }

            if ($response->params['user']['user_id'] === XenForo_Visitor::getUserId())
            {
                $response->templateName = 'MasterBadge_badge_chooser';
                $badges = @unserialize($response->params['user']['favorite_badge']);
                $badges = is_array($badges) ? $badges : array();
                $trophies = $response->params['trophies'];

                $response->params['trophies']['threshold'] = MasterBadge_Core::getFeaturedBadges(MasterBadge_Core::getUserLevel($response->params['user']));
                
                // $response->params['trophies']['featured'] = array_intersect_key($trophies, array_flip($badges));
                $response->params['trophies']['featured'] = array();
                foreach ($badges as $badgeId) 
                {
                    if (isset($trophies[$badgeId]))
                    {
                        $response->params['trophies']['featured'][$badgeId] = $trophies[$badgeId];
                    }
                }
                
                $response->params['trophies']['available'] = array_diff_key($trophies, array_flip($badges));
            }
        }

        return $response;
    }

    public function actionCard()
    {
        $response = parent::actionCard();

        if ($response instanceof XenForo_ControllerResponse_View && XenForo_Application::getOptions()->MasterBadge_memberCard)
        {
            $response->params['user']['favoriteBadges'] = $this->_getBadgeModel()->getUserFeaturedBadges($response->params['user']);
        }

        return $response;
    }
    
    public function actionBadges()
    {
        $userId = $this->_input->filterSingle('user_id', XenForo_Input::UINT);
        $user = $this->getHelper('UserProfile')->assertUserProfileValidAndViewable($userId);

        $this->canonicalizeRequestUrl(XenForo_Link::buildPublicLink('members/badges', $user));

        $badgeModel = $this->_getBadgeModel();
        $userModel = $this->_getUserModel();
        $trophyModel = $this->_getTrophyModel();

        $badges = $badgeModel->getBadgeWithTrophiesForCache();
        $badges = $badgeModel->prepareBadgeForUser($badges, $user);

        // misc
        /*if ($user['following'])
        {
            $followingToShowCount = MasterBadge_Const::FOLLOWING_TO_SHOW_COUNT;
            $followingCount = substr_count($user['following'], ',') + 1;

            $following = $userModel->getFollowedUserProfiles($userId, $followingToShowCount, 'user.trophy_points DESC');

            if (($followingCount >= $followingToShowCount && count($following) < $followingToShowCount)
                || ($followingCount < $followingToShowCount && $followingCount != count($following)))
            {
                // following count is off, rebuild it
                $user['following'] = $userModel->getFollowingDenormalizedValue($user['user_id']);
                $userModel->updateFollowingDenormalizedValue($user['user_id'], $user['following']);

                $followingCount = substr_count($user['following'], ',') + 1;
            }
        }
        else
        {
            $followingCount = 0;

            $following = array();
        }   

        if ($following) 
        {
            foreach ($following as &$followUser) 
            {
                $followUser['canViewActivity'] = $userModel->canViewUserCurrentActivity($followUser);
            }
        }*/

        $viewParams = array(
            'badges' => $badges,
            'user' => $user,

            /*'favoriteBadge' => $user['favorite_badge'] 
                ? $trophyModel->prepareTrophy($trophyModel->getTrophyFromCache($user['favorite_badge']))
                : array(),

            'followingCount' => $followingCount,
            'following' => $following,*/

            'progress' => MasterBadge_Core::getUserLevelProgress($user)
        );

        return $this->responseView('MasterBadge_ViewPublic_Member_Badge', 'MasterBadge_member_badge', $viewParams);
    }

    protected function _getTrophyModel()
    {
        return $this->getModelFromCache('XenForo_Model_Trophy');
    }

    protected function _getBadgeModel()
    {
        return $this->getModelFromCache('MasterBadge_Model_Badge');
    }
}