<?php

class MasterBadge_Deferred_Badge extends XFCP_MasterBadge_Deferred_Badge
{
    public function execute(array $deferred, array $data, $targetRunTime, &$status)
    {
        $badgeModel = XenForo_Model::create('MasterBadge_Model_Badge');
        $badges = $badgeModel->getBadges();
        
        if (!$badges)
        {
            foreach ($badges as $badge) 
            {
                $badgeModel->updateTrophyCount($badge['badge_id']);
            }            
        }

        XenForo_Model::create('XenForo_Model_Trophy')->rebuildTrophiesCache();
        MasterBadge_Helper_Level::rebuildLevelCache();

        $actionPhrase = new XenForo_Phrase('rebuilding');
        $typePhrase = new XenForo_Phrase('MasterBadge_badges');
        $status = sprintf('%s... %s', $actionPhrase, $typePhrase);

        return parent::execute($deferred, $data, $targetRunTime, $status);
    }
}