<?php

abstract class MasterBadge_Option_FeaturedBadges
{
    public static function renderOption(XenForo_View $view, $fieldPrefix, array $preparedOption, $canEdit)
    {
        $value = $preparedOption['option_value'];

        $choices = array();

        $editLink = $view->createTemplateObject('option_list_option_editlink', array(
            'preparedOption' => $preparedOption,
            'canEditOptionDefinition' => $canEdit
        ));

        return $view->createTemplateObject('MasterBadge_option_featured_badges', array(
            'fieldPrefix' => $fieldPrefix,
            'listedFieldName' => $fieldPrefix . '_listed[]',
            'preparedOption' => $preparedOption,
            'formatParams' => $preparedOption['formatParams'],
            'editLink' => $editLink,

            'choices' => $value,
            'nextCounter' => count($value)
        ));
    }

    public static function verifyOption(array &$values, XenForo_DataWriter $dw, $fieldName)
    {
        $output = array();

        foreach ($values AS $value)
        {
            if (!isset($value['level']) || !isset($value['badge']))
            {
                continue;
            }

            if (is_numeric($value['level']) && is_numeric($value['badge']))
            {
                $output[] = $value;
            }
        }

        $values = $output;

        usort($values, function($a, $b) {
            if ($a['level'] == $b['level']) return 0;
            return $a['level'] > $b['level'] ? 1 : -1;
        });

        return true;
    }
}